/*
 * generated by Xtext 2.23.0
 */
package org.xtext.example.datamodel.generator

import org.eclipse.emf.ecore.resource.Resource
import org.eclipse.xtext.generator.AbstractGenerator
import org.eclipse.xtext.generator.IFileSystemAccess2
import org.eclipse.xtext.generator.IGeneratorContext
import org.eclipse.xtext.generator.AbstractFileSystemAccess2
import java.util.HashMap
import org.eclipse.xtext.resource.IGlobalServiceProvider
import org.eclipse.xtext.generator.OutputConfiguration
import org.eclipse.xtext.generator.IFileSystemAccess
import com.google.inject.Inject
import org.xtext.example.model.generator.ModelGenerator
import org.eclipse.xtext.generator.IGenerator2
import org.eclipse.xtext.generator.GeneratorContext
import org.eclipse.core.resources.ResourcesPlugin

/**
 * Generates code from your model files on save.
 * 
 * See https://www.eclipse.org/Xtext/documentation/303_runtime_concepts.html#code-generation
 */
class DatamodelGenerator extends AbstractGenerator {

	@Inject
	private IGlobalServiceProvider serviceProvider;

	override void doGenerate(Resource resource, IFileSystemAccess2 fsa, IGeneratorContext context) { 
		var dslModelFactory = new GenerateModel

		var outputConfigurationsDatamodelMap = this.datamodelOutputConfigurations
		var datamodelGenerationFsa = fsa
		if (fsa instanceof AbstractFileSystemAccess2) {
			(datamodelGenerationFsa as AbstractFileSystemAccess2).setOutputConfigurations(
				outputConfigurationsDatamodelMap)
		}
		var genDslModel = new GenerateModel
		genDslModel.generateModel(resource, datamodelGenerationFsa, context);

		var resourceURI = resource.URI
		var modelFileName = resourceURI.toString.substring(resourceURI.toString.lastIndexOf('/') + 1).replace(
			"datamodel", "model");
			
		if (fsa.isFile(modelFileName)) {
			var modelResourceURI = resourceURI.trimSegments(resourceURI.segments.size - 2).appendSegment("src").
				appendSegment("main").appendSegment("resources").appendSegment(modelFileName)
			if (modelResourceURI.isPlatform) {
				var modelGenerator = serviceProvider.findService(modelResourceURI, ModelGenerator)
				var modelResource = resource.resourceSet.getResource(modelResourceURI, true)
				var modelGenerationFsa = fsa as AbstractFileSystemAccess2
				var outputConfigurationsModelMap = modelOutputConfigurations
				modelGenerationFsa.setOutputConfigurations(outputConfigurationsModelMap)
				var generator = modelGenerator as IGenerator2
				generator.doGenerate(modelResource, modelGenerationFsa, new GeneratorContext)
			}
		}
	}

	def HashMap<String, OutputConfiguration> getDatamodelOutputConfigurations() {
		val outputConfigurationsMap = new HashMap
		var OutputConfiguration defaultOutput = new OutputConfiguration(IFileSystemAccess.DEFAULT_OUTPUT);
		defaultOutput.setDescription("Output Folder");
		defaultOutput.setOutputDirectory("./src/main/resources");
		defaultOutput.setOverrideExistingResources(true);
		defaultOutput.setCreateOutputDirectory(true);
		defaultOutput.setCleanUpDerivedResources(true);
		defaultOutput.setSetDerivedProperty(true);
		defaultOutput.setKeepLocalHistory(true);
		var OutputConfiguration config = new OutputConfiguration("CONFIG");
		config.setDescription("Configuration files location")
		config.setOutputDirectory("./");

		outputConfigurationsMap.put("DEFAULT_OUTPUT", defaultOutput)
		outputConfigurationsMap.put("CONFIG", config)

		return outputConfigurationsMap
	}
	
		def HashMap<String, OutputConfiguration> getModelOutputConfigurations(){
		var outputConfigurationsMap = new HashMap
		val readonlyOutput = new OutputConfiguration("resourceOutput");
        readonlyOutput.setDescription("Resource Output Folder");
        readonlyOutput.setOutputDirectory("src/main/resources");
        readonlyOutput.setOverrideExistingResources(false);
        readonlyOutput.setCreateOutputDirectory(false);
        readonlyOutput.setCleanUpDerivedResources(false);
        readonlyOutput.setSetDerivedProperty(false);
        
        val defaultOutput = new OutputConfiguration(IFileSystemAccess.DEFAULT_OUTPUT);
        defaultOutput.setDescription("Output Folder") ;
        defaultOutput.setOutputDirectory("target/generated-sources/xtext");
        defaultOutput.setOverrideExistingResources(true);
        defaultOutput.setCreateOutputDirectory(true);
        defaultOutput.setCleanUpDerivedResources(true);
        defaultOutput.setSetDerivedProperty(true);
		outputConfigurationsMap.put("resourceOutput", readonlyOutput)
		outputConfigurationsMap.put("DEFAULT_OUTPUT", defaultOutput)
		
		return outputConfigurationsMap
	}
}
