package org.xtext.example.datamodel.generator

import org.eclipse.xtext.generator.IGeneratorContext
import org.eclipse.xtext.generator.IFileSystemAccess2
import org.eclipse.emf.ecore.resource.Resource
import org.xtext.example.datamodel.datamodel.Context

class GenerateModel {
	def generateModel(Resource resource, IFileSystemAccess2 fsa, IGeneratorContext context) {

		var contextInstance = resource.allContents.filter(Context).head

		val configFileExists = fsa.isFile("datamodel-config.xml")
		var CharSequence contentConfigFile;
		if (configFileExists) {
			contentConfigFile = fsa.readTextFile("datamodel-config.xml")
		}
 
		var resourceName = resource.URI.toString.substring(resource.URI.toString.lastIndexOf('/') + 1).replace(
			"datamodel", "model");
		fsa.generateFile(
			resourceName,
			'''
				model {
					name contextInstance.name.substring(0, contextInstance.name.lastIndexOf("-"))
					IF contextInstance.parentContext!==nullextends contextInstance.parentContext.name.substring(0, contextInstance.parentContext.name.lastIndexOf("-"))ENDIF
					version contextInstance.name.substring(contextInstance.name.lastIndexOf("-")+1)
					}
					'''
		)
	}
}
