/**
 * generated by Xtext 2.23.0
 */
package org.xtext.example.datamodel.generator;

import com.google.inject.Inject;
import java.util.HashMap;
import java.util.List;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.xtext.generator.AbstractFileSystemAccess2;
import org.eclipse.xtext.generator.AbstractGenerator;
import org.eclipse.xtext.generator.GeneratorContext;
import org.eclipse.xtext.generator.IFileSystemAccess;
import org.eclipse.xtext.generator.IFileSystemAccess2;
import org.eclipse.xtext.generator.IGenerator2;
import org.eclipse.xtext.generator.IGeneratorContext;
import org.eclipse.xtext.generator.OutputConfiguration;
import org.eclipse.xtext.resource.IGlobalServiceProvider;
import org.eclipse.xtext.xbase.lib.Conversions;
import org.xtext.example.datamodel.generator.GenerateModel;
import org.xtext.example.model.generator.ModelGenerator;

/**
 * Generates code from your model files on save.
 * 
 * See https://www.eclipse.org/Xtext/documentation/303_runtime_concepts.html#code-generation
 */
@SuppressWarnings("all")
public class DatamodelGenerator extends AbstractGenerator {
  @Inject
  private IGlobalServiceProvider serviceProvider;
  
  @Override
  public void doGenerate(final Resource resource, final IFileSystemAccess2 fsa, final IGeneratorContext context) {
    GenerateModel dslModelFactory = new GenerateModel();
    HashMap<String, OutputConfiguration> outputConfigurationsDatamodelMap = this.getDatamodelOutputConfigurations();
    IFileSystemAccess2 datamodelGenerationFsa = fsa;
    if ((fsa instanceof AbstractFileSystemAccess2)) {
      ((AbstractFileSystemAccess2) datamodelGenerationFsa).setOutputConfigurations(outputConfigurationsDatamodelMap);
    }
    GenerateModel genDslModel = new GenerateModel();
    genDslModel.generateModel(resource, datamodelGenerationFsa, context);
    URI resourceURI = resource.getURI();
    String _string = resourceURI.toString();
    int _lastIndexOf = resourceURI.toString().lastIndexOf("/");
    int _plus = (_lastIndexOf + 1);
    String modelFileName = _string.substring(_plus).replace(
      "datamodel", "model");
    boolean _isFile = fsa.isFile(modelFileName);
    if (_isFile) {
      int _size = ((List<String>)Conversions.doWrapArray(resourceURI.segments())).size();
      int _minus = (_size - 2);
      URI modelResourceURI = resourceURI.trimSegments(_minus).appendSegment("src").appendSegment("main").appendSegment("resources").appendSegment(modelFileName);
      boolean _isPlatform = modelResourceURI.isPlatform();
      if (_isPlatform) {
        ModelGenerator modelGenerator = this.serviceProvider.<ModelGenerator>findService(modelResourceURI, ModelGenerator.class);
        Resource modelResource = resource.getResourceSet().getResource(modelResourceURI, true);
        AbstractFileSystemAccess2 modelGenerationFsa = ((AbstractFileSystemAccess2) fsa);
        HashMap<String, OutputConfiguration> outputConfigurationsModelMap = this.getModelOutputConfigurations();
        modelGenerationFsa.setOutputConfigurations(outputConfigurationsModelMap);
        IGenerator2 generator = ((IGenerator2) modelGenerator);
        GeneratorContext _generatorContext = new GeneratorContext();
        generator.doGenerate(modelResource, modelGenerationFsa, _generatorContext);
      }
    }
  }
  
  public HashMap<String, OutputConfiguration> getDatamodelOutputConfigurations() {
    final HashMap<String, OutputConfiguration> outputConfigurationsMap = new HashMap<String, OutputConfiguration>();
    OutputConfiguration defaultOutput = new OutputConfiguration(IFileSystemAccess.DEFAULT_OUTPUT);
    defaultOutput.setDescription("Output Folder");
    defaultOutput.setOutputDirectory("./src/main/resources");
    defaultOutput.setOverrideExistingResources(true);
    defaultOutput.setCreateOutputDirectory(true);
    defaultOutput.setCleanUpDerivedResources(true);
    defaultOutput.setSetDerivedProperty(true);
    defaultOutput.setKeepLocalHistory(Boolean.valueOf(true));
    OutputConfiguration config = new OutputConfiguration("CONFIG");
    config.setDescription("Configuration files location");
    config.setOutputDirectory("./");
    outputConfigurationsMap.put("DEFAULT_OUTPUT", defaultOutput);
    outputConfigurationsMap.put("CONFIG", config);
    return outputConfigurationsMap;
  }
  
  public HashMap<String, OutputConfiguration> getModelOutputConfigurations() {
    HashMap<String, OutputConfiguration> outputConfigurationsMap = new HashMap<String, OutputConfiguration>();
    final OutputConfiguration readonlyOutput = new OutputConfiguration("resourceOutput");
    readonlyOutput.setDescription("Resource Output Folder");
    readonlyOutput.setOutputDirectory("src/main/resources");
    readonlyOutput.setOverrideExistingResources(false);
    readonlyOutput.setCreateOutputDirectory(false);
    readonlyOutput.setCleanUpDerivedResources(false);
    readonlyOutput.setSetDerivedProperty(false);
    final OutputConfiguration defaultOutput = new OutputConfiguration(IFileSystemAccess.DEFAULT_OUTPUT);
    defaultOutput.setDescription("Output Folder");
    defaultOutput.setOutputDirectory("target/generated-sources/xtext");
    defaultOutput.setOverrideExistingResources(true);
    defaultOutput.setCreateOutputDirectory(true);
    defaultOutput.setCleanUpDerivedResources(true);
    defaultOutput.setSetDerivedProperty(true);
    outputConfigurationsMap.put("resourceOutput", readonlyOutput);
    outputConfigurationsMap.put("DEFAULT_OUTPUT", defaultOutput);
    return outputConfigurationsMap;
  }
}
