package org.xtext.example.datamodel.generator;

import com.google.common.collect.Iterators;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.xtend2.lib.StringConcatenation;
import org.eclipse.xtext.generator.IFileSystemAccess2;
import org.eclipse.xtext.generator.IGeneratorContext;
import org.eclipse.xtext.xbase.lib.IteratorExtensions;
import org.xtext.example.datamodel.datamodel.Context;

@SuppressWarnings("all")
public class GenerateModel {
  public void generateModel(final Resource resource, final IFileSystemAccess2 fsa, final IGeneratorContext context) {
    Context contextInstance = IteratorExtensions.<Context>head(Iterators.<Context>filter(resource.getAllContents(), Context.class));
    final boolean configFileExists = fsa.isFile("datamodel-config.xml");
    CharSequence contentConfigFile = null;
    if (configFileExists) {
      contentConfigFile = fsa.readTextFile("datamodel-config.xml");
    }
    String _string = resource.getURI().toString();
    int _lastIndexOf = resource.getURI().toString().lastIndexOf("/");
    int _plus = (_lastIndexOf + 1);
    String resourceName = _string.substring(_plus).replace(
      "datamodel", "model");
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("model {");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("name ");
    String _substring = contextInstance.getName().substring(0, contextInstance.getName().lastIndexOf("-"));
    _builder.append(_substring, "\t");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    {
      Context _parentContext = contextInstance.getParentContext();
      boolean _tripleNotEquals = (_parentContext != null);
      if (_tripleNotEquals) {
        _builder.append("extends ");
        String _substring_1 = contextInstance.getParentContext().getName().substring(0, contextInstance.getParentContext().getName().lastIndexOf("-"));
        _builder.append(_substring_1, "\t");
      }
    }
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.append("version ");
    String _name = contextInstance.getName();
    int _lastIndexOf_1 = contextInstance.getName().lastIndexOf("-");
    int _plus_1 = (_lastIndexOf_1 + 1);
    String _substring_2 = _name.substring(_plus_1);
    _builder.append(_substring_2, "\t");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.append("}");
    _builder.newLine();
    fsa.generateFile(resourceName, _builder);
  }
}
