/*
 * generated by Xtext 2.12.0
 */
package org.xtext.example.model.generator

//import com.google.common.base.CaseFormat
//import com.wkfsfrc.datamodel.model.ComplexType
//import com.wkfsfrc.datamodel.model.Entity
//import com.wkfsfrc.datamodel.model.EntityColumnRef
//import com.wkfsfrc.datamodel.model.Enumeration
//import com.wkfsfrc.datamodel.model.GenericColumn
//import com.wkfsfrc.datamodel.model.IntegerLiteral
//import com.wkfsfrc.datamodel.model.ListType
//import com.wkfsfrc.datamodel.model.Model
//import com.wkfsfrc.datamodel.model.Parameter
//import com.wkfsfrc.datamodel.model.ParameterRef
//import com.wkfsfrc.datamodel.model.Relation
//import com.wkfsfrc.datamodel.model.RelationalExpression
//import com.wkfsfrc.datamodel.model.SimpleColumnRef
//import com.wkfsfrc.datamodel.model.StringLiteral
import java.io.File
import javax.inject.Inject
import org.eclipse.emf.ecore.resource.Resource
import org.eclipse.xtend2.lib.StringConcatenationClient
import org.eclipse.xtext.generator.AbstractGenerator
import org.eclipse.xtext.generator.IFileSystemAccess2
import org.eclipse.xtext.generator.IGeneratorContext
import org.eclipse.xtext.generator.trace.node.TracingSugar

//import static extension com.wkfsfrc.datamodel.typing.DatamodelTypeProvider.*
//import com.wkfsfrc.datamodel.model.SimpleColumn
//import com.wkfsfrc.datamodel.model.Index
import java.util.Properties
import java.nio.file.Files
import java.nio.file.Paths
import org.eclipse.emf.common.util.URI
import java.util.HashMap
import java.util.ArrayList
//import com.wkfsfrc.datamodel.model.GroupExpression
//import com.wkfsfrc.datamodel.model.LiteralExpression
//import com.wkfsfrc.datamodel.model.NumberType
import java.io.FileOutputStream
import java.io.FileInputStream
import java.io.IOException
import org.xtext.example.model.model.Model

/**
 * Generates code from your model files on save.
 * 
 * See https://www.eclipse.org/Xtext/documentation/303_runtime_concepts.html#code-generation
 */
class ModelGenerator extends AbstractGenerator {

//	@Inject extension TracingSugar
//	@Inject extension GeneratedClasses


	public static val MODEL_PROPERTIES_FILE = "model.properties"
	public static val RESOUCE_OUTPUT_CONFIGURATION = "resourceOutput"
	
	public static val TABLE_NAME_PREFIX_PROPERTY = "table.name.prefix"
	public static val TABLE_TECHNICAL_IDENTIFIER_PROPERTY = "table.technical.identifier"		
	public static val NAMING_CONVENTION_PROPERTY = "convention"
	
	public static val PROPERTY_DATASOURCE="datasource"
	public static val PROPERTY_CONFIGURATION="configuration"
	public static val PROPERTY_EXCEPTION="exception"
	public static val PROPERTY_SEQUENCE="sequence"
	public static val PROPERTY_IDENTIFIER="identifier"
	
	val configurationProperties = new Properties();
	override  void beforeGenerate(Resource input, IFileSystemAccess2 fsa, IGeneratorContext context) {
//		
//		configurationProperties.clear;
//		if(fsa.isFile(MODEL_PROPERTIES_FILE,RESOUCE_OUTPUT_CONFIGURATION)){	
//			configurationProperties.load(fsa.readBinaryFile(MODEL_PROPERTIES_FILE,RESOUCE_OUTPUT_CONFIGURATION));
//		}
	}

	override void doGenerate(Resource resource, IFileSystemAccess2 fsa, IGeneratorContext context) {
		var resourceName = resource.URI.toString.substring(resource.URI.toString.lastIndexOf('/') + 1).replace(
			"model", "java");
				fsa.generateFile(
			"org/xtext/example/" + resourceName,
			'''
			package org.xtext.example;
			IF (resource.contents.get(0) as Model).extendedModel != null
				import org.xtext.example.(resource.contents.get(0) as Model).extendedModel.name;
				ENDIF
				public class resourceName.subSequence(0,resourceName.indexOf(".java")) {
					public String name ="(resource.contents.get(0) as Model).name";
					public String version ="(resource.contents.get(0) as Model).version";
					IF (resource.contents.get(0) as Model).extendedModel != null
					public (resource.contents.get(0) as Model).extendedModel.name extendedClass = new (resource.contents.get(0) as Model).extendedModel.name();
					ENDIF
					}
					'''
		)
		
//		resource.allContents.filter(Entity).forEach[(it as Entity).generateView(fsa, context, resource)]
//		resource.allContents.filter(Enumeration).forEach[(it as Enumeration).generateEnumeration(fsa, context, resource)]	
	}

//	def void generateEnumeration(Enumeration enumeration, IFileSystemAccess2 fsa, IGeneratorContext context,Resource resource){
//		 
//		val fileName = enumeration.datamodelTypeFor.javaType.replace('.', File.separatorChar) + '.java'
//		if(enumeration.isGeneratedByDSL && enumeration.enumValues.filter[!it.hasParam].size == 0){
//			fsa.generateTracedFile(fileName, enumeration, enumeration.generateEnumeration)
//		}		
//	}
	
	
//	def void generateView(Entity entity, IFileSystemAccess2 fsa, IGeneratorContext context, Resource resource) {
//		val fileName = entity.datamodelTypeFor.javaType.replace('.', File.separatorChar) + '.java'
//		val byDsl = entity.isGeneratedByDSL
//		if(byDsl){
//			fsa.generateTracedFile(fileName, entity, entity.generateEntity)
//			}
//		if (!entity.fields.filter(GenericColumn).filter[it.primaryKey].empty && entity.extendedTable === null) {
//			val keyFileName = entity.datamodelTypeFor.javaType.replace('.', File.separatorChar) + 'Key.java'
//
//			if(byDsl){
//				fsa.generateTracedFile(keyFileName, entity,	entity.generateKey)
//				val cacheFileName = entity.datamodelTypeFor.javaPackage.replace('.', File.separatorChar) + File.separatorChar + entity.generateCacheConfigName + ".java"
//				val cacheClassName = entity.datamodelTypeFor.javaPackage +"."+entity.generateCacheConfigName
//				if (entity.isClassGeneratedByDsl(cacheClassName)&& entity.owner === null){
//					fsa.generateTracedFile(cacheFileName, entity, entity.generateCacheConfig)
//				}
//			}
//		}
//	}
//			
//	
//	def isPartitionableEntity(Entity entity){
//		entity.modifier === null || entity.modifier == 'partitioned'
//	}
//	
//	def isReplicableEntity(Entity entity){
//		 entity.modifier !== null && entity.modifier == 'replicated'
//	}
//	
//	def isLocalEntity(Entity entity){
//		entity.modifier !== null && entity.modifier == 'local'
//	}
//	
//	def isStreamableEntity(Entity entity){
//		entity.modifier !== null && entity.modifier == 'streamed'
//	}
//
//	def isTransient(Entity entity){
//		entity.accessMode !== null && entity.accessMode == 'none'
//	}
//
//	def isReadOnly(Entity entity){
//		entity.accessMode !== null && entity.accessMode == 'read-only'
//	}
//	
//	def isWriteOnly(Entity entity){
//		entity.accessMode !== null && entity.accessMode == 'write-only'
//	}
//
//	def isReadWrite(Entity entity){
//		entity.accessMode === null || entity.accessMode == 'read-write'
//	}
//
//	def isStatic(Entity entity){
//		entity.type == 'reference-data'
//	}
//	
//	def isProcessCacheType(Entity entity){
//		entity.cacheType == 'process'
//	}
//
//	def StringConcatenationClient generateEnumeration(Enumeration enumeration){
//		'''
//		package «enumeration.datamodelTypeFor.javaPackage»;
//		
//		«generateDSLHeader»
//		public enum «enumeration.name.toFirstUpper» {
//		«FOR enums: enumeration.enumValues SEPARATOR ','»
//			«enums.name»(«FOR valueEnum : enums.values SEPARATOR ', '»«valueEnum.generate»«ENDFOR»)
//		«ENDFOR»;
//			
//			«FOR key: enumeration.fields.filter(GenericColumn)»
//			private «key.datamodelField2Type.javaType» «key.name.toFirstLower»;
//			«ENDFOR»
//			
//			«enumeration.name.toFirstUpper»(«FOR key: enumeration.fields.filter(GenericColumn) SEPARATOR ", "»«key.datamodelField2Type.javaType» «key.name.toFirstLower»«ENDFOR») {
//				«FOR key: enumeration.fields.filter(GenericColumn)»
//				this.«key.name.toFirstLower» = «key.name.toFirstLower»;
//				«ENDFOR»
//			}
//			
//			«FOR key: enumeration.fields.filter(GenericColumn)»
//			public «key.datamodelField2Type.javaType» get«key.name.toFirstUpper»() {
//				return «key.name.toFirstLower»;
//			}
//			
//			«ENDFOR»
//			«IF enumeration.fields.filter(GenericColumn).filter[it.primaryKey].size>0»
//			public static «enumeration.name.toFirstUpper» of(«enumeration.fields.filter(GenericColumn).filter[it.primaryKey].head.datamodelField2Type.javaType» «enumeration.fields.filter(GenericColumn).filter[it.primaryKey].head.name.toFirstLower»){
//				switch(«enumeration.fields.filter(GenericColumn).filter[it.primaryKey].head.name») {
//					«FOR enums: enumeration.enumValues»
//					«IF enums.values.size > 0»
//					case «enums.values.get(0).generate»:
//						return «enums.name»;
//					«ENDIF»
//					«ENDFOR»
//					default: return null;
//				}
//			}
//			«ENDIF»
//		}
//		'''
//	}
//	
//	
//	def StringConcatenationClient generateKey(Entity entity) {
//	
//							'''
//			package «entity.datamodelTypeFor.javaPackage»;
//			
//			import java.io.Serializable;
//			import java.util.Objects;
//			
//			«entity.generateKeyClass»
//			'''
//	}
//	
//	def StringConcatenationClient generateKeyClass(Entity entity) {
//							'''
//			«generateDSLHeader»
//			public class «entity.name.toFirstUpper»Key implements Serializable {
//				
//				private static final long serialVersionUID = 1L;
//				«IF entity.fields.filter(GenericColumn).filter[it.primaryKey].size > 0»
//				public «entity.name.toFirstUpper»Key() {
//				}
//				«ENDIF»
//				
//				public «entity.name.toFirstUpper»Key(«FOR key: entity.fields.filter(GenericColumn).filter[it.primaryKey].sortBy[it.name] SEPARATOR ", "»«key.datamodelField2Type.javaType» «key.name.toFirstLower»«ENDFOR») {
//					«FOR key: entity.fields.filter(GenericColumn).filter[it.primaryKey]»
//					this.«key.name.toFirstLower» = «key.name.toFirstLower»;
//					«ENDFOR»
//				}
//				
//«««				Fields
//				«FOR field: entity.fields.filter(GenericColumn).filter[it.isPrimaryKey]»
//				private «field.datamodelField2Type.javaType» «field.name.toFirstLower»;
//				«ENDFOR»
//				
//«««				Getters and setters for fields				
//				«FOR field: entity.fields.filter(GenericColumn).filter[it.isPrimaryKey]»	
//				public «field.datamodelField2Type.javaType» get«field.name.toFirstUpper»() {
//					return  «field.name.toFirstLower»;
//				}
//				
//				public void set«field.name.toFirstUpper»(«field.datamodelField2Type.javaType» «field.name.toFirstLower») {
//					this.«field.name.toFirstLower» = «field.name.toFirstLower»;
//				}
//				«ENDFOR»
//				
//				@Override
//				public boolean equals(Object o) {
//					if (this == o) return true;
//					if (o == null || getClass() != o.getClass()) return false;
//					«entity.name.toFirstUpper»Key that = («entity.name.toFirstUpper»Key) o;
//					return «FOR key: entity.fields.filter(GenericColumn).filter[it.primaryKey] SEPARATOR " && "»
//							(«key.name.toFirstLower».equals(that.get«key.name.toFirstUpper»()))
//							«ENDFOR»;
//				}
//			
//				@Override
//				public int hashCode() {
//					return Objects.hash(«FOR key: entity.fields.filter(GenericColumn).filter[it.primaryKey] SEPARATOR ", "»«key.name.toFirstLower»«ENDFOR»);
//				}
//
//				@Override
//				public String toString() {
//					return "«entity.name.toFirstUpper»Key [«FOR key: entity.fields.filter(GenericColumn).filter[it.primaryKey] SEPARATOR ", "»«key.name.toFirstLower»=" + «key.name.toFirstLower» + "«ENDFOR»]";
//				}
//
//			}
//			'''
//	}
//	
//	def StringConcatenationClient generateClass(Entity entity) {
//		'''
//			«generateDSLHeader»
//			«IF entity.extendedTable === null»
//				«var configurationVariable = entity.generateConfigurationName»
//				«var keyTypeVariable = if(entity.fields.filter(GenericColumn).filter[it.primaryKey].empty)  "void.class" else entity.name.toFirstUpper+"Key.class"»
//				@com.wolterskluwer.processing.model.Entity(configuration = «configurationVariable».class, keyType = «keyTypeVariable»)
//			«ENDIF»
//			«IF entity.extendedTable !== null»
//			@com.wolterskluwer.processing.model.Entity.Extension(code = "«(entity.eContainer as Model).countryCode»", baseType = «entity.extendedTable.datamodelTypeFor.javaType».class)
//			«ENDIF»
//			«IF !entity.transient»
//			«generateTableAnnotation(entity.name)»
//			«ENDIF»
//			public interface «entity.name.toFirstUpper» extends Serializable«IF entity.extendedTable === null», com.wolterskluwer.newreg.model.Extendable«ENDIF»{
//				
//				static final long serialVersionUID = 1L;
//				
//«««				Getters and setters for fields
//				«FOR field: entity.fields.filter(GenericColumn)»	
//				«IF (!(field.type instanceof ListType) && !(field.type instanceof ComplexType) && !entity.transient)»
//				«field.generateColumnAnnotation(entity)»
//				«ENDIF»
//				«FOR index :  entity.fields.filter(Index).filter[it.parameters.contains(field)]»
//				@com.wolterskluwer.processing.model.Entity.Index(name = "«index.name»", rank = «index.parameters.indexOf(field)»)
//				«ENDFOR»
//				«IF !field.isTechnicalID»«field.datamodelField2Type.javaType»«ELSE»Long«ENDIF» get«field.name.toFirstUpper»();
//
//				void set«field.name.toFirstUpper»(«IF !field.isTechnicalID»«field.datamodelField2Type.javaType»«ELSE»Long«ENDIF» «field.name.toFirstLower»);
//				
//				«ENDFOR»
//				
//«««				Relation
//				«FOR field: entity.fields.filter(Relation).filter[it.hasOnlyEqualsOperator]»	
//				«IF field.refEntity.owner === null»
//				«field.generateRelationHeader»
//				«field.functionReturnType» get«field.name.toFirstUpper»(«FOR param : field.parameters SEPARATOR ', '»«param.getDataType(field).datamodelField2Type.javaType» param«param.name.replace("#","")»«ENDFOR»);
//				
//				«ELSE»
//				«var subEntity = (entity.eContainer as Model).elements.filter(Entity).map[it as Entity].filter[it?.owner == entity].head»			
//				«subEntity.createAmountAlias(field)»
//				«ENDIF»
//				«ENDFOR»
//«««				 	
//«««					Fields for embedded classes=
//					«FOR subEntity : (entity.eContainer as Model).elements.filter(Entity).map[it as Entity].filter[it?.owner == entity]»
//					«IF subEntity.owner !== null»
//					@com.wolterskluwer.processing.model.Entity.Relation(joinFields = {«FOR field : entity.fields.filter(GenericColumn).filter[it.isPrimaryKey] SEPARATOR " , "»@com.wolterskluwer.processing.model.Entity.Relation.JoinField(name="«field.name»", referencedName = "«field.name»")«ENDFOR»})					
//					java.util.Map<«subEntity.datamodelTypeFor.javaType»Key, «subEntity.datamodelTypeFor.javaType»> get«subEntity.name.toFirstUpper»();
//
//
//					void set«subEntity.name.toFirstUpper»(java.util.Map<«subEntity.datamodelTypeFor.javaType»Key, «subEntity.datamodelTypeFor.javaType»> «subEntity.name.toFirstLower»);
//
//«««					Getter for embedded class with key
//					«IF !subEntity.fields.filter(GenericColumn).filter[it.primaryKey].isEmpty»
//«««					«subEntity.name.toFirstUpper» get«subEntity.name.toFirstUpper»(«FOR key: subEntity.fields.filter(GenericColumn).filter[it.primaryKey] SEPARATOR ", "»«key.datamodelField2Type.javaType» «key.name.toFirstLower»«ENDFOR»);
//
//					public default «subEntity.name.toFirstUpper» get«subEntity.name.toFirstUpper»(«subEntity.name.toFirstUpper»Key «subEntity.name.toFirstLower»Key){
//						return get«subEntity.name.toFirstUpper»().get(«subEntity.name.toFirstLower»Key);
//					}
//					«ENDIF»
//					«ENDIF»
//				«ENDFOR»
//			}
//		'''
//	}
//	
//	def String generateConfigurationName(Entity entity){
//		if(entity.owner !== null){
//			return entity.owner.cacheConfig ?: entity.owner.generateCacheConfigName
//		}else{
//			return entity.cacheConfig ?: entity.generateCacheConfigName
//		}
//	}
//	
		// Add for backwards compatibility with dfmm maven plugin
//	def isTechnicalID(GenericColumn field) {
//		val configurationIdentifierProperty =  getConfigurationProperty(PROPERTY_CONFIGURATION, TABLE_TECHNICAL_IDENTIFIER_PROPERTY)
//		if (configurationIdentifierProperty !== null &&  field.name.equals(configurationIdentifierProperty) && field.type instanceof NumberType) 
//		return true
//		else
//		return false;
//	}
//	
//	def StringConcatenationClient createAmountAlias(Entity subEntity, Relation field){
//		val paramMap = new HashMap
//		subEntity.fields.filter(GenericColumn).filter[isPrimaryKey].sortBy[it.name].forEach[paramMap.put(it, null)]
//		(field.condition as GroupExpression).expression.eAllContents.filter(ParameterRef).forEach[paramMap.replace(it.eContainer.eAllContents.filter(EntityColumnRef).head.value, "param"+ it.value.name.replace("#","") )]
//		(field.condition as GroupExpression).expression.eAllContents.filter(LiteralExpression).forEach[paramMap.replace(it.eContainer.eAllContents.filter(EntityColumnRef).head.value, it.generate )]
//
//		paramMap.entrySet.forEach[if(it.value === null){paramMap.replace(it.key, "get"+it.key.name.toFirstUpper+"()")}]		
//
//		'''
//		public default «field.functionReturnType» get«field.name.toFirstUpper»(«FOR param : field.parameters SEPARATOR ', '»«param.getDataType(field).datamodelField2Type.javaType» param«param.name.replace("#","")»«ENDFOR»){
//			«subEntity.name.toFirstUpper»Key «subEntity.name.toFirstLower»Key = new  «subEntity.name.toFirstUpper»Key(«FOR parameter : paramMap.entrySet.sortBy[it.key.name] SEPARATOR ', '»«parameter.value»«ENDFOR»); 
//			return get«subEntity.name.toFirstUpper»().get(«subEntity.name.toFirstLower»Key);
//		}
//		'''
//				
//	}
//	
//	def StringConcatenationClient generateColumnAnnotation(GenericColumn field, Entity entity){
//		val entityName = entity.name
//		val identifierProperty = getConfigurationProperty(PROPERTY_IDENTIFIER, entityName)
//		val configurationIdentifierProperty =  getConfigurationProperty(PROPERTY_CONFIGURATION, TABLE_TECHNICAL_IDENTIFIER_PROPERTY)
//		val identifier = if(identifierProperty!== null&& field.name.equals(identifierProperty.replace("\"",""))){
//			identifierProperty.replace("\"","")
//		}else if(identifierProperty === null && configurationIdentifierProperty!== null && field.name.equals(configurationIdentifierProperty.replace("\"",""))){
//			 configurationIdentifierProperty.replace("\"","")
//		}
//	
//		val databaseSequenceName = getConfigurationProperty(PROPERTY_SEQUENCE,entityName)
//		'''«IF identifier !== null »@com.wolterskluwer.processing.model.persistence.GeneratedValue«IF databaseSequenceName !== null»(sequenceName = "«databaseSequenceName»")«ENDIF»«ENDIF»
//@com.wolterskluwer.processing.model.persistence.Column(name = "«field.name.generateColumnName»", jdbcType = «field.datamodelField2Type.sqlType»)'''
//	}
//	
//	def generateColumnName(String field) {
//		val databaseColumn =getConfigurationProperty(PROPERTY_EXCEPTION, field)
//		val namingConvention = getConfigurationProperty(PROPERTY_CONFIGURATION, NAMING_CONVENTION_PROPERTY)		
//		if(databaseColumn !== null){
//			return databaseColumn.trim().replace("\"","")
//		}
//		if(namingConvention !== null && namingConvention.equals("TO_LOWERCASE")){
//			return CaseFormat.UPPER_CAMEL.to(CaseFormat.LOWER_UNDERSCORE, field)
//		}
//		return CaseFormat.UPPER_CAMEL.to(CaseFormat.UPPER_UNDERSCORE, field)
//	}
//	
//	def StringConcatenationClient functionReturnType(Relation entity){
//		/*if(entity.refEntity.owner !== null){
//			return '''java.util.Map<«entity.datamodelField2Type.javaType»Key, «entity.datamodelField2Type.javaType»>'''
//		}else*/ if(entity.relation !== null && !entity.relation.toUpperCase.equals("ONE")){
//			return '''java.util.List<«entity.datamodelField2Type.javaType»>'''
//		}else{
//			return '''«entity.datamodelField2Type.javaType»'''
//		}
//	}
//	
//	def boolean hasOnlyEqualsOperator(Relation relation){
//		 relation.eAllContents.filter(RelationalExpression).filter[!it.operator.equals("==")].size == 0
//	}
//	
//	def GenericColumn getDataType(Parameter parameter, Relation relation){
//		val parameterEntity = relation.condition.eAllContents.filter(ParameterRef).filter[it.value.equals(parameter)]?.head
//		return (parameterEntity.eContainer as RelationalExpression).left.relationValue
//	}
//	
//	def StringConcatenationClient generateRelationHeader(Relation relation){
//		var relationList = relation.condition.eAllContents.filter(RelationalExpression).toList
//		if(relationList.size === 0){
//			relationList = relation.eAllContents.filter(RelationalExpression).toList
//		}
//		val finalRelationList = relationList
//		val relationParameterColumns = relation.condition.eAllContents.filter(EntityColumnRef).map[value].toList
//		val pkFieldList = if(relation.refEntity.owner !== null){
//			(relation.eContainer as Entity).fields.filter(GenericColumn).filter[it.isPrimaryKey]
//			val pkList = (relation.eContainer as Entity).fields.filter(GenericColumn).filter[it.isPrimaryKey].toList
//			var outputList=new ArrayList()
//			for(pk: pkList){
//				if(relationParameterColumns.filter[it.name.equals(pk.name)].size == 0){
//					outputList.add(pk)
//				}
//			}
//			outputList;
//		}else{
//			new ArrayList()
//		}
//		
//		//
//		'''@com.wolterskluwer.processing.model.Entity.Relation(joinFields = {«FOR relationExpression : finalRelationList SEPARATOR " , "»«relationExpression.generateJoinFields»«ENDFOR»«IF pkFieldList.size > 0»,«ENDIF»«FOR field : pkFieldList SEPARATOR " , "»@com.wolterskluwer.processing.model.Entity.Relation.JoinField(name="«field.name»", referencedName = "«field.name»")«ENDFOR»})'''	
//	}
//	
//	def dispatch relationValue(SimpleColumnRef reference){
//		reference.value
//	}
//	 
//	 def dispatch relationValue(EntityColumnRef reference){
//		reference.value
//	}
//	
//	def StringConcatenationClient generateJoinFields(RelationalExpression relation){
//		
//		if(relation.right instanceof ParameterRef || relation.right instanceof LiteralExpression){
//			'''@com.wolterskluwer.processing.model.Entity.Relation.JoinField(referencedName="«relation.left.generateNamevalue»", value = "«relation.right.generateNamevalue»")'''
//		}else{
//			if(relation.right instanceof EntityColumnRef){
//				if(relation.left instanceof LiteralExpression){
//					'''@com.wolterskluwer.processing.model.Entity.Relation.JoinField(value="«relation.left.generateNamevalue»", referencedName = "«relation.right.generateNamevalue»")'''		
//				}else{
//					'''@com.wolterskluwer.processing.model.Entity.Relation.JoinField(name="«relation.left.generateNamevalue»", referencedName = "«relation.right.generateNamevalue»")'''			
//				}
//			}else{
//				'''@com.wolterskluwer.processing.model.Entity.Relation.JoinField(name="«relation.right.generateNamevalue»", referencedName = "«relation.left.generateNamevalue»")'''		
//			}
//		}
//	}
//	
//	def dispatch generateNamevalue(StringLiteral parameter){
//		'''«parameter.value»'''
//	}	
//	
//	def dispatch generateNamevalue(IntegerLiteral parameter){
//		'''«parameter.value»'''
//	}	
//	
//	def dispatch generate(IntegerLiteral parameter){
//		'''«parameter.value»'''
//	}	
//	
//	def dispatch generate(StringLiteral parameter){
//		'''"«parameter.value»"'''
//	}	
//	
//	def dispatch generateNamevalue(ParameterRef parameter){
//		val argNumber = Integer.parseInt(parameter.value.name.replace("#",""))
//		'''${arg«argNumber-1»}'''
//	}
//	
//	def dispatch generateNamevalue(EntityColumnRef parameter){
//		'''«parameter.value.name»'''
//	}
//	
//	def dispatch generateNamevalue(SimpleColumnRef parameter){
//		'''«parameter.value.name»'''
//	}
//	
//	def StringConcatenationClient generateEntity(Entity entity){
//		'''
//			package «entity.datamodelTypeFor.javaPackage»;
//			
//			import java.util.Objects;
//			import java.io.Serializable;
//			import java.util.Collection;
//			
//			«entity.generateClass»
//		'''
//	}
//	
//	
//	def String generateDSLHeader(){
//		'''@javax.annotation.Priority(value = 1)'''
//	}
//	
//	def getConfigurationProperty(String key, String value) {
//		return configurationProperties.getProperty(key+"."+value)
//		/*if(configurationProperties.containsKey(key)&& configurationProperties.get(key).containsKey(value)){
//			return configurationProperties.get(key).get(value)
//		}*/
//	}
//	
//	private def String generateTableAnnotation(String tableName) {
//		val tableNamePrefix = getConfigurationProperty(PROPERTY_CONFIGURATION,TABLE_NAME_PREFIX_PROPERTY)
//		val namingConvention = getConfigurationProperty(PROPERTY_CONFIGURATION, NAMING_CONVENTION_PROPERTY)
//		val databaseTableName = getConfigurationProperty(PROPERTY_EXCEPTION, tableName)
//		val prefix = if (tableNamePrefix !== null) {
//			tableNamePrefix
//		} else {
//			""
//		}
//		val temp = tableName.toCharArray.reverse
//		// this part is required because the translation of strings like
//		// ContractCH is CONTRACT_C_H, thus, we need to first transform to
//		// ContractCh and then apply the transformation
//		val lenghtOfEnd = if (Character.isUpperCase(temp.head)) {
//			temp.takeWhile[Character.isUpperCase(it)].size - 1
//		} else {
//			0
//		}
//		
//		val fixedName = if(databaseTableName !== null){
//			databaseTableName.trim().replace("\"","")
//		}else{
//			var tabName = tableName.substring(0, tableName.length - lenghtOfEnd) + tableName.substring(tableName.length - lenghtOfEnd).toLowerCase;
//			if(namingConvention !== null && namingConvention.equals("TO_LOWERCASE")){
//				(prefix + CaseFormat.UPPER_CAMEL.to(CaseFormat.LOWER_UNDERSCORE, tabName)).toLowerCase		
//			}else{
//				(prefix + CaseFormat.UPPER_CAMEL.to(CaseFormat.UPPER_UNDERSCORE, tabName)).toUpperCase			
//			}
//		}
//		'''
//			@com.wolterskluwer.processing.model.persistence.Table(name = "«fixedName»")
//		'''
//	}
//	
//
//
//	def StringConcatenationClient generateCacheConfig(Entity entity) {
//		val namingConvention = getConfigurationProperty(PROPERTY_CONFIGURATION, NAMING_CONVENTION_PROPERTY)?:""
//		val configurationName = entity.generateCacheConfigName.replace("_Configuration","")
//		val sourceDatasource = getConfigurationProperty(PROPERTY_DATASOURCE, configurationName+".source")
//		val targetDatasource = getConfigurationProperty(PROPERTY_DATASOURCE, configurationName+".target")
//		
//		'''
//		package «entity.datamodelTypeFor.javaPackage»;
//		
//		«generateDSLHeader»
//		@com.wolterskluwer.processing.model.Configuration.Name("«configurationName»")
//		«IF entity.static»@com.wolterskluwer.processing.ReferenceData«ENDIF»
//		«IF entity.isPartitionableEntity»
//		@com.wolterskluwer.processing.model.Configuration.EntityMode(value = com.wolterskluwer.processing.model.Configuration.EntityMode.Mode.PARTITIONED)
//		«ELSEIF entity.isReplicableEntity»
//		@com.wolterskluwer.processing.model.Configuration.EntityMode(value = com.wolterskluwer.processing.model.Configuration.EntityMode.Mode.REPLICATED)
//		«ELSEIF entity.isLocalEntity»
//		@com.wolterskluwer.processing.model.Configuration.EntityMode(value = com.wolterskluwer.processing.model.Configuration.EntityMode.Mode.LOCAL)
//		«ELSEIF entity.isStreamableEntity»
//		@com.wolterskluwer.processing.model.Configuration.EntityMode(value = com.wolterskluwer.processing.model.Configuration.EntityMode.Mode.STREAMED)
//		«ENDIF»			
//		«IF entity.readOnly»
//		@com.wolterskluwer.processing.model.Configuration.Persistence(value = com.wolterskluwer.processing.model.Configuration.Persistence.Mode.LOAD)
//		@com.wolterskluwer.processing.model.Configuration.Access(value = com.wolterskluwer.processing.model.Configuration.Access.Mode.READ_ONLY)
//		@com.wolterskluwer.processing.model.Configuration.Loader(type = com.wolterskluwer.processing.model.EntityLoader«IF entity.transient».Nop«ELSE».Jdbc«ENDIF».class«IF sourceDatasource !== null», sourceLogicalName="«sourceDatasource»"«ENDIF»)
//		«ELSEIF entity.readWrite»
//		@com.wolterskluwer.processing.model.Configuration.Persistence(value = {com.wolterskluwer.processing.model.Configuration.Persistence.Mode.LOAD, com.wolterskluwer.processing.model.Configuration.Persistence.Mode.WRITE})
//		@com.wolterskluwer.processing.model.Configuration.Access(value = com.wolterskluwer.processing.model.Configuration.Access.Mode.READ_WRITE)
//		@com.wolterskluwer.processing.model.Configuration.Loader(type = com.wolterskluwer.processing.model.EntityLoader«IF entity.transient».Nop«ELSE».Jdbc«ENDIF».class«IF sourceDatasource !== null», sourceLogicalName="«sourceDatasource»"«ENDIF»)
//		@com.wolterskluwer.processing.model.Configuration.Writer(type = com.wolterskluwer.processing.model.EntityWriter«IF entity.transient».Nop«ELSE».Jdbc«ENDIF».class«IF targetDatasource !== null», targetLogicalName="«targetDatasource»"«ENDIF»)
//		«ELSEIF entity.writeOnly»
//		@com.wolterskluwer.processing.model.Configuration.Persistence(value = com.wolterskluwer.processing.model.Configuration.Persistence.Mode.WRITE)
//		@com.wolterskluwer.processing.model.Configuration.Access(value = com.wolterskluwer.processing.model.Configuration.Access.Mode.WRITE_ONLY)
//		@com.wolterskluwer.processing.model.Configuration.Writer(type = com.wolterskluwer.processing.model.EntityWriter«IF entity.transient».Nop«ELSE».Jdbc«ENDIF».class«IF targetDatasource !== null», targetLogicalName="«targetDatasource»"«ENDIF»)
//		«ENDIF»
//		«FOR param : entity.fields.filter(SimpleColumn).filter[it.primaryKey&& it.isContextual]»
//		@com.wolterskluwer.processing.model.Configuration.Binding(parameter = "«param.name»", property = "«CaseFormat.UPPER_CAMEL.to(CaseFormat.UPPER_CAMEL, param.name)»")
//		«ENDFOR»
//		«IF entity.isProcessCacheType»
//		@com.wolterskluwer.processing.model.Configuration.Binding(parameter = "executionId", property = "executionId")
//		«ENDIF»
//		public class «entity.generateCacheConfigName» implements com.wolterskluwer.processing.model.Configuration {
//		}	
//		'''
//	}
//
//
//	
//	def String generateCacheConfigName(Entity entity) {
//		val idFields = entity.fields.filter(SimpleColumn).filter[primaryKey].filter[contextual].map[name].sort.join('_') // will be at least one
//		var configName = (entity.eContainer as Model).name.substring(1).toLowerCase.toFirstUpper+"_"
//		//var configName = ""
//
//		
//		if(entity.isPartitionableEntity){
//			configName += "Partitioned_"
//		}else if(entity.isStreamableEntity){
//			configName += "Streamed_"
//		}else if(entity.isLocalEntity){
//			configName += "Local_"
//		}else if(entity.isReplicableEntity){
//			configName += "Replicated_"
//		}
//		
//		if(entity.isReadOnly){
//			configName += "ReadOnly_"
//		}else if(entity.isReadWrite){
//			configName += "ReadWrite_"
//		}else if(entity.isWriteOnly){
//			configName += "WriteOnly_"
//		}else{
//			configName += "Transient_"
//		}
//		
//		if(entity.static){
//			configName += "ReferenceData_"
//		}
//		if(!idFields.isEmpty){ 
//			configName +=  idFields + "_"
//		}
//		return configName + 'Configuration'
//	}		
}
