/**
 * generated by Xtext 2.12.0
 */
package org.xtext.example.model.generator;

import com.google.common.base.Objects;
import java.util.Properties;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.xtend2.lib.StringConcatenation;
import org.eclipse.xtext.generator.AbstractGenerator;
import org.eclipse.xtext.generator.IFileSystemAccess2;
import org.eclipse.xtext.generator.IGeneratorContext;
import org.xtext.example.model.model.Model;

/**
 * Generates code from your model files on save.
 * 
 * See https://www.eclipse.org/Xtext/documentation/303_runtime_concepts.html#code-generation
 */
@SuppressWarnings("all")
public class ModelGenerator extends AbstractGenerator {
  public static final String MODEL_PROPERTIES_FILE = "model.properties";
  
  public static final String RESOUCE_OUTPUT_CONFIGURATION = "resourceOutput";
  
  public static final String TABLE_NAME_PREFIX_PROPERTY = "table.name.prefix";
  
  public static final String TABLE_TECHNICAL_IDENTIFIER_PROPERTY = "table.technical.identifier";
  
  public static final String NAMING_CONVENTION_PROPERTY = "convention";
  
  public static final String PROPERTY_DATASOURCE = "datasource";
  
  public static final String PROPERTY_CONFIGURATION = "configuration";
  
  public static final String PROPERTY_EXCEPTION = "exception";
  
  public static final String PROPERTY_SEQUENCE = "sequence";
  
  public static final String PROPERTY_IDENTIFIER = "identifier";
  
  private final Properties configurationProperties = new Properties();
  
  @Override
  public void beforeGenerate(final Resource input, final IFileSystemAccess2 fsa, final IGeneratorContext context) {
  }
  
  @Override
  public void doGenerate(final Resource resource, final IFileSystemAccess2 fsa, final IGeneratorContext context) {
    String _string = resource.getURI().toString();
    int _lastIndexOf = resource.getURI().toString().lastIndexOf("/");
    int _plus = (_lastIndexOf + 1);
    String resourceName = _string.substring(_plus).replace(
      "model", "java");
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("package org.xtext.example;");
    _builder.newLine();
    {
      EObject _get = resource.getContents().get(0);
      Model _extendedModel = ((Model) _get).getExtendedModel();
      boolean _notEquals = (!Objects.equal(_extendedModel, null));
      if (_notEquals) {
        _builder.append("import org.xtext.example.");
        EObject _get_1 = resource.getContents().get(0);
        String _name = ((Model) _get_1).getExtendedModel().getName();
        _builder.append(_name);
        _builder.append(";");
        _builder.newLineIfNotEmpty();
      }
    }
    _builder.append("\t");
    _builder.append("public class ");
    CharSequence _subSequence = resourceName.subSequence(0, resourceName.indexOf(".java"));
    _builder.append(_subSequence, "\t");
    _builder.append(" {");
    _builder.newLineIfNotEmpty();
    _builder.append("\t\t");
    _builder.append("public String name =\"");
    EObject _get_2 = resource.getContents().get(0);
    String _name_1 = ((Model) _get_2).getName();
    _builder.append(_name_1, "\t\t");
    _builder.append("\";");
    _builder.newLineIfNotEmpty();
    _builder.append("\t\t");
    _builder.append("public String version =\"");
    EObject _get_3 = resource.getContents().get(0);
    String _version = ((Model) _get_3).getVersion();
    _builder.append(_version, "\t\t");
    _builder.append("\";");
    _builder.newLineIfNotEmpty();
    {
      EObject _get_4 = resource.getContents().get(0);
      Model _extendedModel_1 = ((Model) _get_4).getExtendedModel();
      boolean _notEquals_1 = (!Objects.equal(_extendedModel_1, null));
      if (_notEquals_1) {
        _builder.append("\t\t");
        _builder.append("public ");
        EObject _get_5 = resource.getContents().get(0);
        String _name_2 = ((Model) _get_5).getExtendedModel().getName();
        _builder.append(_name_2, "\t\t");
        _builder.append(" extendedClass = new ");
        EObject _get_6 = resource.getContents().get(0);
        String _name_3 = ((Model) _get_6).getExtendedModel().getName();
        _builder.append(_name_3, "\t\t");
        _builder.append("();");
        _builder.newLineIfNotEmpty();
      }
    }
    _builder.append("\t\t");
    _builder.append("}");
    _builder.newLine();
    fsa.generateFile(
      ("org/xtext/example/" + resourceName), _builder);
  }
}
